#include "NFC.h"
#include <SPI.h>
#include <PubSubClient.h>
#include <MFRC522.h>

NFC::NFC(int pin_ss, int pin_rst)
{
    SPI.begin();

    rfid = new MFRC522(pin_ss, pin_rst);
    rfid->PCD_Init();
}

bool NFC::hasNewCard()
{
    if(rfid->PICC_IsNewCardPresent() && rfid->PICC_ReadCardSerial() && rfid->uid.sak == 0x20)
    {
        byte atqaLen = sizeof(atqa);
        MFRC522::StatusCode status = rfid->PICC_RequestA(atqa, &atqaLen);
        Serial.printf("PICC_RequestA: 0x%02x\n", status);
        if(atqa[0] == 0x44)
        {
            return true;
        }
    }
    return false;
}

void NFC::selectCard()
{
    MFRC522::StatusCode status = rfid->PICC_Select(&(rfid->uid));
    Serial.printf("PICC_Select: 0x%02x\n", status);
    uid = rfid->uid;
    cardSelected = true;
    Serial.println("Card Selected");
}
void NFC::deselectCard()
{
    MFRC522::StatusCode status = rfid->PICC_HaltA();
    Serial.printf("PICC_HaltA: 0x%02x\n", status);
    cardSelected = false;
}

bool NFC::isCardLost()
{
    Serial.println(rfid->PICC_ReadCardSerial());
    Serial.println(rfid->PICC_ReadCardSerial());
    Serial.println(rfid->PICC_ReadCardSerial());
    return rfid->PICC_ReadCardSerial() && rfid->uid.uidByte != uid.uidByte;
}

MFRC522::StatusCode NFC::Transceive(byte* command, byte command_len, byte* response, byte response_len)
{
    return rfid->PCD_TransceiveData(command, command_len, response, &response_len, NULL, 0, true);
}